/* $Id: ace.c,v 1.8 2006/12/26 15:52:25 khorben Exp $ */



#include <stdint.h>
#include <time.h>
#include "plugin.h"


/* types */
#pragma pack(1)
struct ace
{
	uint16_t crc;
	uint16_t size;
	uint8_t type;
	uint16_t flags;
	char string[7];
	uint8_t extract;
	uint8_t create;
	uint8_t host;
	uint8_t volume;
	uint32_t time;
};
#pragma pack()


/* variables */
/* signatures */
static char sig[] = "**ACE**";

/* plugin */
PluginType plugin_type = PT_ARCHIVE | PT_COMPRESSION;
char const plugin_name[] = "ACE";
PluginMagic plugin_magic[] =
{
	{ sizeof(struct ace),	7,	sig,	sizeof(sig)-1	},
	{ 0,			0,	NULL,	0,		}
};


/* functions */
static int _callback_size(PluginHelper * ph, uint16_t size);
static int _callback_time(PluginHelper * ph, time_t mtime);
int plugin_callback(PluginHelper * ph, FILE * fp)
{
	struct ace buf;
	int score = 0;

	if(fread(&buf, sizeof(buf), 1, fp) != 1)
		return 0;
	score+=_callback_size(ph, buf.size) / 2;
	score+=_callback_time(ph, buf.time) / 2;
	ph->printf(ph, "\n");
	return score;
}

static int _callback_size(PluginHelper * ph, uint16_t size)
{
	ph->printf(ph, "%s%d", "size ", size);
	return 100;
}

static int _callback_time(PluginHelper * ph, time_t mtime)
{
	struct tm tm;
	char tmp[22];

	if(gmtime_r(&mtime, &tm) == NULL || strftime(tmp, sizeof(tmp),
			", %d/%m/%Y %H:%M:%S", &tm) == 0)
	{
		ph->printf(ph, "%s", ", unknown date");
		return 0;
	}
	ph->printf(ph, "%s", tmp);
	return mtime < time(NULL) ? 100 : 0;
}
