/* $Id: bzip2.c,v 1.9 2006/12/26 15:52:25 khorben Exp $ */



#include <stdio.h>
#include <string.h>
#include "plugin.h"


/* variables */
/* signatures */
static char sig1[] = "BZh1\x31\x41\x59\x26\x53\x59";
static char sig2[] = "BZh2\x31\x41\x59\x26\x53\x59";
static char sig3[] = "BZh3\x31\x41\x59\x26\x53\x59";
static char sig4[] = "BZh4\x31\x41\x59\x26\x53\x59";
static char sig5[] = "BZh5\x31\x41\x59\x26\x53\x59";
static char sig6[] = "BZh6\x31\x41\x59\x26\x53\x59";
static char sig7[] = "BZh7\x31\x41\x59\x26\x53\x59";
static char sig8[] = "BZh8\x31\x41\x59\x26\x53\x59";
static char sig9[] = "BZh9\x31\x41\x59\x26\x53\x59";
static char flbck1[] = "\x31\x41\x59\x26\x53\x59";
static char flbck2[] = "\x17\x72\x45\x38\x50\x90";
static char flbck3[] = "BZh";

/* plugin */
PluginType plugin_type = PT_COMPRESSION;
char const plugin_name[] = "BZIP2";
PluginMagic plugin_magic[] =
{
	{ sizeof(sig1),		0,	sig1,	sizeof(sig1)-1	},
	{ sizeof(sig2),		0,	sig2,	sizeof(sig2)-1	},
	{ sizeof(sig3),		0,	sig3,	sizeof(sig3)-1	},
	{ sizeof(sig4),		0,	sig4,	sizeof(sig4)-1	},
	{ sizeof(sig5),		0,	sig5,	sizeof(sig5)-1	},
	{ sizeof(sig6),		0,	sig6,	sizeof(sig6)-1	},
	{ sizeof(sig7),		0,	sig7,	sizeof(sig7)-1	},
	{ sizeof(sig8),		0,	sig8,	sizeof(sig8)-1	},
	{ sizeof(sig9),		0,	sig9,	sizeof(sig9)-1	},
	{ sizeof(flbck1),	4,	flbck1,	sizeof(flbck1)-1},
	{ sizeof(flbck2),	4,	flbck2,	sizeof(flbck2)-1},
	{ sizeof(flbck3),	0,	flbck3,	sizeof(flbck3)-1},
	{ 0,			0,	NULL,	0,		}
};


/* functions */
int plugin_callback(PluginHelper * ph, FILE * fp)
{
	char buf[4+sizeof(flbck1)];

	if(fread(&buf, sizeof(buf), 1, fp) != 1)
		return 0;
	if(strncmp("BZh", buf, 3) != 0)
		return 0;
	if(buf[3] < '0' || buf[3] > '9')
		return 0;
	ph->printf(ph, "compression %c\n", buf[3]);
	if(memcmp(&buf[4], flbck1, sizeof(flbck1)-1) == 0
			|| memcmp(&buf[4], flbck2, sizeof(flbck2)-1) == 0)
		return 100;
	return 50;
}
